#ifndef DUNE_ANNULUS_CURVE_CONVERGENCE_TEST_PROBLEM_HH
#define DUNE_ANNULUS_CURVE_CONVERGENCE_TEST_PROBLEM_HH

#include <dune/particle/problem/genericIncludes.hh>

#include <dune/particle/surface/planarCircularSurface.hh>
#include <dune/particle/particle/circularParticle.hh>
#include <dune/particle/integrand/mongeGaugeIntegrand.hh>
#include <dune/fufem/functiontools/basisinterpolator.hh>

#include <dune/particle/derivative/derivativeVectorField_MongeGaugeSpecialization.hh>

class AnnulusCurveConvegenceTestSolution
  : public Dune::VirtualMultiDifferentiableFunction<Dune::FieldVector<double,2>,Dune::FieldVector<double,1>,Dune::FieldVector<size_t,2>>
{
  public:

    typedef Dune::FieldVector<double,2> DomainType;
    typedef Dune::FieldVector<double,1> RangeType;
    typedef Dune::FieldVector<size_t,2> OrderType;

    typedef Dune::VirtualMultiDifferentiableFunction<DomainType,RangeType,OrderType> BaseType;
    using BaseType::evaluate;

    AnnulusCurveConvegenceTestSolution(const double r0, const double r1, const double height, const double slope_)
    {
      // Coefficients as generated by MATLAB.  t2 = r0_*r0_;
      // Alternative: One could also explicitly solve the characterizing linear system here.

      const auto slope = -slope_;

      const double t2 = r0*r0;
      const double t3 = r1*r1;
      const double t4 = log(r0);
      const double t5 = log(r1);
      const double t6 = t3*t3;
      const double t7 = t5*t5;
      const double t8 = t2*t2;
      const double t9 = t4*t4;
      const double t10 = t2*t3*t4*t5*8.0;
      const double t13 = t2*t3*2.0;
      const double t14 = t2*t3*t9*4.0;
      const double t15 = t2*t3*t7*4.0;
      const double t11 = t6+t8+t10-t13-t14-t15;
      const double t12 = 1.0/t11;
      const double t16 = r0*slope*t2;
      const double t17 = r0*slope*t3*t5*2.0;

      c[0] = t12*(height*t6-height*t2*t3-height*t2*t3*t4*2.0+height*t2*t3*t5*2.0-height*t2*t3*t7*4.0-r0*slope*t4*t6+height*t2*t3*t4*t5*4.0+r0*slope*t2*t3*t4+r0*slope*t2*t3*t7*2.0-r0*slope*t2*t3*t4*t5*2.0);
      c[1] = t12*(t16+t17+height*t2*t4*4.0-height*t3*t5*4.0-r0*slope*t3-r0*slope*t2*t4*2.0-r0*slope*t3*t7*4.0+r0*slope*t3*t4*t5*4.0)*(1.0/2.0);
      c[2] = r0*t12*(slope*t6-slope*t2*t3-height*r0*t3*t4*4.0+height*r0*t3*t5*4.0+slope*t2*t3*t4*2.0-slope*t2*t3*t5*2.0);
      c[3] = t12*(t16+t17-height*t2*2.0+height*t3*2.0-r0*slope*t3-r0*slope*t3*t4*2.0);
    }

    RangeType evaluate(const DomainType& x, const OrderType& d) const
    {
      RangeType res = 0;

      const auto r = x.two_norm();
      const auto r2 = r*r;
      const auto r4 = r2*r2;

      if(d[0] == 0 && d[1] == 0){
        res = c[0] + c[1]*r2 + c[2]*log(r) + c[3]*r2*(log(r)-0.5);
      }else if(d[0] == 1 && d[1] == 0){
        res = 2*c[1]*x[0] + (c[2]*x[0])/r2 + c[3]*x[0]*log(r2);
      }else if(d[0] == 0 && d[1] == 1){
        res = 2*c[1]*x[1] + (c[2]*x[1])/r2 + c[3]*x[1]*log(r2);
      }else if(d[0] == 1 && d[1] == 1){
        res = (2*x[0]*x[1]*(c[3]*r2-c[2]))/r4;
      }else if(d[0] == 2 && d[1] == 0){
        res = 2*c[1] + c[3] + c[2]/r2 + c[3]*(log(r2)-1) - (2*c[2]*x[0]*x[0])/r4 + (2*c[3]*x[0]*x[0])/r2;
      }else if(d[0] == 0 && d[1] == 2){
        res = 2*c[1] + c[3] + c[2]/r2 + c[3]*(log(r2)-1) - (2*c[2]*x[1]*x[1])/r4 + (2*c[3]*x[1]*x[1])/r2;
      }else{
        DUNE_THROW(Dune::NotImplemented, "Not implemented.");
      }

      return res;
    }


  private:

    std::array<double,4> c;
};


class AnnulusCurveConvergenceTestProblem
{
  public:

    typedef Dune::BlockVector<Dune::FieldVector<double,1>> Vector;

    typedef PlanarCircularSurface<> Surface;
    typedef CircularParticle<> Particle;
    typedef SpatialTransformation<> Transformation;
    typedef ParameterizedMembraneParticleProblem<Surface,Particle,Transformation> Model;
    typedef typename Model::Position Position;

    typedef typename Dune::UGGrid<2> Grid;
    typedef typename Grid::LeafGridView GridView;
    typedef HermiteKNodalBasis<GridView,2> NonconformingBasis;
    typedef ConformingKBasis<NonconformingBasis> Basis;

    typedef typename Model::ConstraintFunctions ConstraintFunctions;
    typedef typename Model::LevelSetFunctions LevelSetFunctions;
    typedef DomainInformation<Basis,LevelSetFunctions> DomainInfo;
    typedef ConstraintFunction<ConstraintFunctions,DomainInfo> Constraints;
    typedef MongeGaugeIntegrand<Constraints> Integrand;
    typedef MembraneAssembler<Integrand,DomainInfo> Assembler;
    typedef MembraneSolver<Model,Basis> Solver;

    /*static constexpr double radius = exp(-1);
    static constexpr double height = (exp(2)-3)/4.;
    static constexpr double slope  = exp(1);*/
    
    const double radius;
    const double height;
    const double slope;

    AnnulusCurveConvergenceTestProblem(const double radius = exp(-1), const double height = (exp(2)-3)/4., const double slope = exp(1))
      : radius(radius), height(height), slope(slope),
        u(0), surface(1), particle(radius,height,slope), transformation()
    {
    }

    Position initialPosition(const double r = 0) const
    {
      Position position(1);
      position[0] = 0;
      position[0][0] = r;
      return position;
    }
    
    double solve(const double h, const double r = 0)
    {
      return solve(h, initialPosition(r));
    }

    double solve(const double h, const Position& position)
    {
      surface.setPadding(2.6634358*h);
      
      // Reset quadrature caches.
      LocalParameterizationQuadratureCache<double>::clear();
      CurveQuadratureCache<double,2>::clear();

      // Full model.
      //~ position[0][0]  = 3e-7;
      //~ position[0][1]  = -2.6e-6;
      pModel = std::make_shared<Model>(surface, particle, transformation);
      pModel->setNumberOfParticles(position.size());
      pModel->setPosition(position);
      const auto& model = *pModel;

      // Set up grid.
      pGrid = ( Particle::type == ParticleType::Point ) ? MembraneGrid::template makeGridContainingPoints(model, h) : MembraneGrid::template makeGrid(model, h);

      // Set up basis.
      pNonconformingBasis = std::make_shared<NonconformingBasis>(pGrid->leafGridView());
      pBasis = std::make_shared<Basis>(*pNonconformingBasis);
      surface.updateConstraints(*pBasis);
      const auto& basis = *pBasis;

      // Collect geometric information.
      levelSetFunctions = model.transformedLevelSets();
      pDomainInfo = std::make_shared<DomainInfo>(basis, levelSetFunctions, 1);
      const auto& domainInfo = *pDomainInfo;
      Debug::dprint("DomainInfo constructed.");

      // Set integrand.
      const auto&& constraintFunctions = model.transformedConstraintFunctions();
      Constraints f(constraintFunctions, domainInfo);
      Integrand integrand(1,0,f);

      // Assemble system.
      Assembler assembler(integrand, domainInfo);
      const auto&& constraintPoints = model.transformedParameterizedPoints();
      Debug::dprint("Assembled.");

      // Solve system.
      pMembraneSolver = std::make_shared<Solver>(assembler.systemMatrix(), assembler.rightHandSide(), model, basis, constraintPoints);
      u = pMembraneSolver->solve();

      // Compute energy.
      Vector Au(u.size());
      assembler.volumeMatrix().mv(u,Au);
      const auto energy = 0.5*(u*Au);
      Debug::dprint("Got energy", energy);
      return energy;
    }


    void solveExactly(const double h) // (up to interpolation error)
    {
      // Reset quadrature caches.
      LocalParameterizationQuadratureCache<double>::clear();
      CurveQuadratureCache<double,2>::clear();

      // Full model.
      typename Model::Position position(1);
      position[0] = 0;
      pModel = std::make_shared<Model>(surface, particle, transformation);
      pModel->setNumberOfParticles(position.size());
      pModel->setPosition(position);
      const auto& model = *pModel;

      // Set up grid.
      pGrid = ( Particle::type == ParticleType::Point ) ? MembraneGrid::template makeGridContainingPoints(model, h) : MembraneGrid::template makeGrid(model, h);

      // Set up basis.
      pNonconformingBasis = std::make_shared<NonconformingBasis>(pGrid->leafGridView());
      pBasis = std::make_shared<Basis>(*pNonconformingBasis);
      surface.updateConstraints(*pBasis);
      const auto& basis = *pBasis;

      // Collect geometric information.
      levelSetFunctions = model.transformedLevelSets();
      pDomainInfo = std::make_shared<DomainInfo>(basis, levelSetFunctions, 1);
      const auto& domainInfo = *pDomainInfo;
      Debug::dprint("DomainInfo constructed.");

      // Interpolate exact solution.
      AnnulusCurveConvegenceTestSolution f(radius, 1, height, slope);
      u.resize(basis.size());
      Functions::interpolate(basis, u, f);
    }


    void saveMembrane(const std::string& fileName = "membrane", const int refinement = 0)
    {
      // Visualize.
      const auto& model = *pModel;
      const auto& domainInfo = *pDomainInfo;
            auto& basis = *pBasis;

      typedef Dune::CutOffBasis<Basis,typename Model::Function,DomainInfo> COBasis;
      COBasis coBasis(basis, domainInfo);
      const auto&& levelSetFunctions = model.transformedLevelSets();
      for(const auto& levelSetFunction : levelSetFunctions)
        coBasis.addInterface(levelSetFunction);

      typedef ParametricPerturbedSurface<Surface,COBasis,Vector> PerturbedSurface;
      PerturbedSurface perturbedSurface(surface, coBasis, u);
      typedef Dune::VTKFunction<typename COBasis::GridView> VTKFunction;
      std::shared_ptr<VTKFunction> vtkFunction = std::make_shared<PerturbedSurface>(perturbedSurface);

      typedef VTKBasisGridFunction<COBasis,Vector> VTKGridFunction;
      std::shared_ptr<VTKGridFunction> vtkGridFunction = std::make_shared<VTKGridFunction>(coBasis, u, "elevation");

      Dune::SubsamplingVTKWriter<typename COBasis::GridView> writer(basis.getGridView(), refinement);
      writer.addVertexData(vtkFunction);
      writer.addVertexData(vtkGridFunction);

      writer.write(fileName, Dune::VTK::OutputType::base64);
      Debug::dprint("Wrote surface.");
    }

    const auto& membrane() const
    {
      return u;
    }

    const auto& basis() const
    {
      return *pBasis;
    }


    // Approach here: Use a high order quadrature rule on the coarse
    // grid and apply it against the exact solution function.
    auto measureError() const
    {
      Dune::FieldVector<double,3> error(0.);
      const auto& basis       = *pBasis;
      const auto& domainInfo  = *pDomainInfo;

      // Set up functions.
      BasisMultiDifferentiableGridFunction<Basis,Vector,Dune::FieldVector<size_t,2>> func_u(basis, u);
      AnnulusCurveConvegenceTestSolution func_ex(radius, 1, height, slope);

      // Iterate over all elements.
      for(const auto& e : elements(basis.getGridView()))
      {
        // Get quadrature rule.
        const bool isInside   = domainInfo.isInside(e);
        const bool isOutside  = domainInfo.isOutside(e);

        if(isOutside)
          continue;

        const auto tFE = basis.getLocalFiniteElement(e);
        QuadratureRuleKey quadKey(tFE);
        quadKey.setOrder(tFE.localBasis().order()*2 + 10);
        auto quadratureRule = (isInside) ? QuadratureRuleCache<double,2>::rule(quadKey) : LocalParameterizationQuadrature<double>::rule(quadKey, e, domainInfo);

        for(const auto& quadPoint : quadratureRule)
        {
          // Update error term.
          const auto& xLocal = quadPoint.position();
          const auto xGlobal = e.geometry().global(xLocal);
          const auto weight = quadPoint.weight()*e.geometry().integrationElement(xLocal);

          const auto dif_H0   = func_u.evaluateLocal(e,xLocal) - func_ex.evaluate(xGlobal);
          auto dif_H1 = func_u.evaluateLocalGradient(e,xLocal);
          dif_H1[0] -= func_ex.evaluate(xGlobal,{1,0});
          dif_H1[1] -= func_ex.evaluate(xGlobal,{0,1});
          // old: dif_H2 = func_u.evaluateLaplacianLocal(e,xLocal) - func_ex.evaluate(xGlobal,{2,0}) - func_ex.evaluate(xGlobal,{0,2});
          double dif_H2_2 = 0;
          for(size_t i = 0; i < 2; ++i)
            for(size_t j = 0; j < 2; ++j)
            {
              const auto c = func_u.evaluateLocal(e,xLocal,{i,j}) - func_ex.evaluate(xGlobal,{i,j});
              dif_H2_2  += c*c;
            }
          
          error[0] += dif_H0*dif_H0*weight;
          error[1] += (dif_H1*dif_H1)*weight;
          error[2] += dif_H2_2*weight;
        }
      }

      for(auto& e : error)
        e = sqrt(e);
      return error;
    }

    auto gradient() const
    {
      // Preparations.
      const auto& model = *pModel;
      const auto&& constraintFunctions = model.transformedConstraintFunctions();
      const auto& domainInfo = *pDomainInfo;
      Constraints f(constraintFunctions, domainInfo);
      Integrand integrand(1,0,f);

      // Compute derivative.
      typedef DerivativeVectorField_MongeGaugeSpecialization<DomainInfo,Model,Solver> VectorField;
      //~ typedef DerivativeVectorField<DomainInfo,Model,Solver> VectorField;
      VectorField V(domainInfo, model, *pMembraneSolver);

      typedef ParticleDerivative<Integrand,VectorField,DomainInfo,Vector> Derivative;
      Derivative derivative(integrand, V, domainInfo, u);

      Debug::dprint("Evaluating gradient.");
      const auto dif = derivative.evaluateGradient(model.getPosition());
      Debug::dprint("Evaluated gradient.");

      return dif;
    }


  protected:

    Dune::ParameterTree params;

          Surface         surface;
    const Particle        particle;
    const Transformation transformation;

    LevelSetFunctions levelSetFunctions;

    std::shared_ptr<Grid>               pGrid;
    std::shared_ptr<NonconformingBasis> pNonconformingBasis;
    std::shared_ptr<Basis>              pBasis;
    std::shared_ptr<DomainInfo>         pDomainInfo;
    std::shared_ptr<Model>              pModel;
    std::shared_ptr<Solver>             pMembraneSolver;

    Vector u;
};
#endif
